<nz-drawer
  [nzBodyStyle]="{ overflow: 'auto', paddingBottom: '4rem' }"
  [nzMaskClosable]="true"
  [nzWidth]="780"
  [nzVisible]="visible"
  [nzTitle]="excludePair"
  (nzOnClose)="close()"
>
  <nz-spin [nzSpinning]="pair === undefined" >
    <div *ngIf="pair">

      <div *ngIf="pair.exclusion.severityPlus.severity" class="card mb-4" [ngStyle]="{borderColor : colorsv2[pair.exclusion.severityPlus.severity]}">
        <div class="card-header" [ngStyle]="{borderColor : colorsv2[pair.exclusion.severityPlus.severity]}">

          <h6 [ngStyle]="{color :colorsv2[pair.exclusion.severityPlus.severity], display : 'inline-block'}">A été signalée &nbsp;</h6>
          <nz-tag [nzColor]="colorsv2[pair.exclusion.severityPlus.severity]">
            <i nz-icon nzType="exclamation-circle"></i>
            <span>{{pair.exclusion.severityPlus.description | uppercase}}</span>
          </nz-tag>
          <div class="ml-5 d-inline-block">Par : <strong>{{pair.exclusion.excludeBy}}</strong> </div>
          <div class="ml-5 d-inline-block">Le : <strong>{{pair.exclusion.date | date}}</strong></div>
        </div>
        <div class="card-body">
          <nz-divider nzText="Raisons : " nzOrientation="left"></nz-divider>
          <ul>
            <li *ngFor="let reason of pair.exclusion.reasonsPlus">{{reason.description}}</li>
          </ul>
          <nz-divider nzText="Note : " nzOrientation="left"></nz-divider>
          <p>{{pair.exclusion.note}}</p>

        </div>
      </div>

      <div *ngIf="!pair.exclusion.severityPlus.severity" class="card mb-4" style="border-color: green">
        <h6 class="card-header" style="color: green; border-color: green">
          A été signalée : <nz-tag nzColor="success"><i nz-icon nzType="check-circle"></i><span>Non </span></nz-tag>
        </h6>
        <div class="card-body">
          <div><nz-empty [nzNotFoundContent]="null"></nz-empty></div>
        </div>
      </div>

      <div style="width: 90%; margin: auto; padding: 5% 0">
        <app-isfor-slider [showTooltip]="false"> </app-isfor-slider>
      </div>

      <div class="card mb-4">
        <h6 class="card-header">Frequences <nz-tag nzColor="default">Pour {{isfor}} $</nz-tag> </h6>
        <div class="card-body">
          <ul class="list-group">
            <li style="color: #0099ff" class="list-group-item d-flex justify-content-between align-items-center">
              <span>A obtenu le <strong>meilleur Spread</strong></span>
              <nz-tag nzColor="#0099ff">{{pair.isfor[isfor].isBestFreq}}</nz-tag>
            </li>
            <li style="color: green" class="list-group-item d-flex justify-content-between align-items-center">
             <span> A obtenu un <strong>spread Positif</strong></span>
              <nz-tag nzColor="green">{{pair.isfor[isfor].positiveFreq}}</nz-tag>
            </li>
            <li style="color: orange" class="list-group-item d-flex justify-content-between align-items-center">
              <span>A obtenu un <strong>spread Négatif</strong></span>
              <nz-tag nzColor="orange">{{pair.isfor[isfor].negativeFreq}}</nz-tag>
            </li>
            <li class="list-group-item d-flex justify-content-between align-items-center">
              <span>A eu un <strong> volume insuffisant</strong></span>
              <nz-tag nzColor="default">{{pair.isfor[isfor].notEnoughtVolFreq}}</nz-tag>
            </li>
            <li style="color: #ff0000" class="list-group-item d-flex justify-content-between align-items-center">
              <span>A eu une <strong> erreur de calcul</strong></span>
              <nz-tag nzColor="#ff0000">{{pair.isfor[isfor].errorFreq}}</nz-tag>
            </li>
          </ul>
        </div>
      </div>

      <div class="card mb-4">
        <h6 class="card-header">Quand la paire est <strong>Positive</strong> </h6>
        <div class="card-body">
          <h6 class="card-title">Les spreads <nz-tag nzColor="default">Pour {{isfor}} $</nz-tag> </h6>
          <nz-list nzBordered nzSize="small">

            <nz-list-item>
              <nz-list-item-meta
                nzTitle="Profit moyen en quote"
                nzDescription="Représente les gains moyens en {{pair.quote.name}} pour {{isfor}}$ de {{pair.base.name}} acheté puis revendu"
              ></nz-list-item-meta>
              <kbd>{{pair.isfor[isfor].spreadMoyen_quote | exponentiel : 7}} {{pair.quote.name}}</kbd>
            </nz-list-item>

            <nz-list-item>
              <nz-list-item-meta
                nzTitle="Profits max en 1 coup"
                nzDescription="Représente les gains max $ gagnés en 1 coup"
              ></nz-list-item-meta>
              <nz-tag nzColor="blue">{{pair.isfor[isfor].hightestSpread_usd | exponentiel : 2}} $</nz-tag>
            </nz-list-item>

            <nz-list-item>
              <nz-list-item-meta
                nzTitle="Profits moyen en usd "
                nzDescription="Représente les gains moyens en dollar pour {{isfor}} $ investis"
              ></nz-list-item-meta>
              <span nz-typography>
                <i class="mr-2" nz-icon nzType="thunderbolt" nzTheme="twotone"></i>
                <strong style="color: #0099ff ; font-size: 100%">{{pair.isfor[isfor].spreadMoyen_usd | exponentiel : 2}} $</strong>
              </span>
            </nz-list-item>
          </nz-list>
          <br>
          <h6 class="card-title">Le volume <nz-tag nzColor="default">Pour {{isfor}} $</nz-tag>  </h6>
          <nz-list nzBordered nzSize="small">
            <nz-list-item>
              <nz-list-item-meta
                nzTitle="Volume moyen {{pair.base.name}}"
                nzDescription="Représente la qté moyenne de {{pair.base.name}} pour {{isfor}}$ "
              ></nz-list-item-meta>
              <mark>{{pair.isfor[isfor].volumeMoyen_base | exponentiel : 7}} {{pair.base.name}}</mark>
            </nz-list-item>

          </nz-list>
        </div>
      </div>

      <div class="card">
        <h6 class="card-header">Les Markets de cette pair </h6>
        <div class="card-body">
          <nz-list nzBordered nzSize="small">


            <nz-list-item >
              <nz-list-item-meta nzTitle="Markets enregistrés pour cette pair"></nz-list-item-meta>
              <nz-tag nzColor="default">{{pair.marketsForThis}}</nz-tag>
            </nz-list-item>

            <nz-list-item >
              <nz-list-item-meta nzTitle="Markets en services pour cette pair"></nz-list-item-meta>
              <nz-tag nzColor="green">{{marketsOn}}</nz-tag>
            </nz-list-item>

            <nz-list-item >
              <nz-list-item-meta nzTitle="Markets hors services pour cette pair"></nz-list-item-meta>
              <nz-tag nzColor="red">{{pair.marketsForThis - marketsOn}}</nz-tag>
            </nz-list-item>

          </nz-list>
          <br>

          <ng-container>
            <a href="/markets/{{symbol.market.name}}" target="_blank" class="d-inline-block mr-2" *ngFor="let symbol of symbols">
                <nz-badge [nzDot]="!!symbol.exclusion.isExclude">
                  <nz-tag class="mb-2 mr-0 market"
                          [nzColor]="colors[
                          symbol.market.exclusion.severity === 4 ? 4 : 0 ||
                          symbol.exclusion.severity ]"
                  >
                    {{symbol.market.name}}

                  </nz-tag>
                </nz-badge>
            </a>
            <p style="font-size: 10px">*Dans le cadre d'un market --> éliminé <-- : Si ce dernier possède un point rouge dans son angle haut-droit,
              cela signifie qu'il est éliminé de la paire uniquement! Sans point rouge, c'est le market entier qui est éliminé.
            </p>

          </ng-container>

        </div>


<!--Classement des markets de la pair pour l'achat et la vente-->
        <h5 style="text-align: center">Classement des markets pour la pair {{pair.name}} <nz-tag nzColor="default">Pour {{isfor}} $</nz-tag> </h5>
        <br>

        <!--Le systeme de trie et filtres-->
        <nz-radio-group class="ml-3 mb-2" (ngModelChange)="makeList($event)" [(ngModel)]="list.sorter" nzName="radiogroup">
          <label nz-radio nzValue="prixMoyen_quote">Prix Moyen($)</label>
          <label nz-radio nzValue="bestMarketFreq">Freq Best [M] pour {{pair.name}}</label>
          <nz-switch nzSize="small" nzCheckedChildren="en services" nzUnCheckedChildren="tous" [(ngModel)]="list.hideBanned" (ngModelChange)="makeList()"></nz-switch>
        </nz-radio-group>

        <!--Systeme de recherche de markets-->
        <nz-input-group class="ml-3 mt-2 mb-3" style="width: 15rem" [nzSuffix]="suffixIconSearch">
          <input type="text" nz-input placeholder="Chercher un market" (ngModelChange)="makeList(undefined,$event)" [(ngModel)]="list.search" />
        </nz-input-group>
        <ng-template #suffixIconSearch><i nz-icon nzType="search"></i></ng-template>

          <div nz-row style="min-height: 500px">
            <!--Tableau d'achat-->
            <aside nz-col [nzSpan]="12" >
              <h6 class="text-center m0" style="color: limegreen">ACHAT</h6>
              <nz-table #buyTablee
                        [nzData]="list.buy"
                        nzSize="small"
                        [(nzPageSize)]="paginate.pageSize"
                        nzShowSizeChanger
                        [(nzPageIndex)]="paginate.pageIndex"
              >
                <thead >
                <tr >
                  <th class="listbuy"><i nz-icon nzType="delete" nzTheme="outline"></i></th>
                  <th class="listbuy">prix moyen </th>
                  <th style="font-size: 90%" class="listbuy" nz-popover
                      nzPopoverContent="Frequence où un market à été le meilleur en achat pour cette paire ({{pair.name}}) ">
                    Freq <br> best [M]
                  </th>
                  <th class="listbuy">Market</th>
                </tr>
                </thead>
                <tbody>
                <tr  style="font-weight: 500" [ngClass]="{alertBan : symb.exclusion.isExclude || symb.market.exclusion.isExclude  }"
                     *ngFor="let symb of buyTablee.data; let i = index">
                  <td style="text-align: center">
                    <app-report-symbols (afterUpdate)="onUpdate(true)" class="mr-2" *ngIf="pair" [symbols]="[symb]" [selectMultiple]="false" >
                      <nz-badge [nzDot]="symb.exclusion.severity > 0"  [nzStyle]="{ backgroundColor: colors[symb.exclusion.severity]}">
                        <button nz-button nzShape="circle" nzSize="small"><i  nz-icon nzType="delete"></i></button>
                      </nz-badge>
                    </app-report-symbols>
                  </td>
                  <td style="color: green">
                    <ng-container *ngIf="!!symb.isfor[isfor].buy.prixMoyen_quote" > {{ symb.isfor[isfor].buy.prixMoyen_quote | exponentiel : 4}} {{pair.quote.name}}</ng-container>
                    <ng-container *ngIf="!symb.isfor[isfor].buy.prixMoyen_quote" >No data</ng-container>
                  </td>
                  <td>
                    <nz-tag nzColor="blue">
                      <strong>{{ symb.isfor[isfor].buy.bestMarketFreq }}</strong> / {{ symb.isfor[isfor].buy.okFreq +  symb.isfor[isfor].buy.notEnoughVolFreq + symb.isfor[isfor].buy.notDataFreq }}
                    </nz-tag>
                  </td>
                  <td style="text-align: right">
                    <a target="_blank" href="/markets/{{symb.market.name}}">
                      {{ symb.market.name }} &nbsp; <span class="badge badge-success">{{i + 1 + paginate.pageSize * (paginate.pageIndex - 1)}}</span>
                    </a>
                  </td>

                </tr>
                </tbody>
              </nz-table>
            </aside>
            <!--Tableau de vente-->
            <aside nz-col [nzSpan]="12">
              <h6 class="text-center" style="color: #ffbb00">VENTE</h6>
              <nz-table #sellTable
                        [nzData]="list.sell"
                        nzSize="small"
                        [(nzPageSize)]="paginate.pageSize"
                        nzShowSizeChanger
                        [(nzPageIndex)]="paginate.pageIndex"
              >
                <thead >
                <tr >
                  <th class="listsell">Market</th>
                  <th style="font-size: 90%" class="listsell"  nz-popover
                      nzPopoverContent="Frequence où un market à été le meilleur en vente pour cette paire ({{pair.name}}) ">
                    Freq <br> best [M]
                  </th>
                  <th class="listsell">prix moyen </th>
                  <th class="listsell"><i nz-icon nzType="delete" nzTheme="outline"></i></th>
                </tr>
                </thead>
                <tbody>
                <tr  style="font-weight: 500" [ngClass]="{alertBan : symb.exclusion.isExclude || symb.market.exclusion.isExclude  }"
                     *ngFor="let symb of sellTable.data; let i = index">
                  <td>
                    <a target="_blank" href="/markets/{{symb.market.name}}">
                      <span class="badge badge-warning">{{i + 1 + paginate.pageSize * (paginate.pageIndex - 1)}}</span>&nbsp;{{ symb.market.name }}
                    </a>
                  </td>
                  <td><nz-tag nzColor="blue"><strong>{{ symb.isfor[isfor].sell.bestMarketFreq }}</strong> / {{ symb.isfor[isfor].sell.okFreq +  symb.isfor[isfor].sell.notEnoughVolFreq + symb.isfor[isfor].sell.notDataFreq }}</nz-tag></td>
                  <td style="color: #ff9900">
                    <ng-container *ngIf="!!symb.isfor[isfor].sell.prixMoyen_quote" > {{ symb.isfor[isfor].sell.prixMoyen_quote | exponentiel : 4}} {{pair.quote.name}}</ng-container>
                    <ng-container *ngIf="!symb.isfor[isfor].sell.prixMoyen_quote" >No data</ng-container>
                  </td>
                  <td style="text-align: right">
                    <app-report-symbols  (afterUpdate)="onUpdate(true)" class="mr-2" *ngIf="pair" [symbols]="[symb]" [selectMultiple]="false" >
                      <nz-badge [nzDot]="symb.exclusion.severity > 0"  [nzStyle]="{ backgroundColor: colors[symb.exclusion.severity]}">
                        <button nz-button nzShape="circle" nzSize="small"><i  nz-icon nzType="delete"></i></button>
                      </nz-badge>
                    </app-report-symbols>
                  </td>
                </tr>
                </tbody>
              </nz-table>
            </aside>
        </div>
      </div>

    </div>
  </nz-spin>
</nz-drawer>

<!-------Templates----------->
<ng-template #excludePair>
  <div *ngIf="pair">
    <span class="mr-3">{{pair.name}}</span>
    <app-report-pairs (afterUpdate)="onUpdate(true)" class="mr-2" *ngIf="pair" [pairs]="[pair]" >
      <nz-badge [nzDot]="pair.exclusion.severityPlus.severity > 0"  [nzStyle]="{ backgroundColor: colors[pair.exclusion.severityPlus.severity]}" >
        <button nz-button nzType="danger" nzShape="circle"><i  nz-icon nzType="delete"></i></button>
      </nz-badge>
    </app-report-pairs>
    <nz-tag *ngIf="pair.exclusion.isExclude" nzColor="red">éliminée</nz-tag>

    <div (click)="onUpdate()" style="cursor: pointer" class="d-inline-block ml-2" nz-popover nzPopoverContent="rafraichir">
      <i nz-icon nzType="redo" [nzSpin]="loading" style="color: dodgerblue" nzTheme="outline"></i>
    </div>
  </div>
</ng-template>
